

public class ARadioINSHUTDOWN implements Runnable {
    
    //Instanz-Variablen, hergeleitet aus dem FSP-Prozess
    private final static int MAX = 108;
    private final static int MIN = 88;
    private int f;
    
    private enum State {OFF, LOCKED, DOWN, UP, INSHUTDOWN}
    private State state;

    //Instanz-Variablen fuer die Implementierung
    private boolean[] sender;
    private Thread operator;


    public ARadioINSHUTDOWN() {
        f = 0;
        state = State.OFF;
        sender = new boolean[MAX + 1];
        int[] frequencies = {91, 94, 100, 101, 102, 106};
        for(int frequency : frequencies) {
            sender[frequency] = true;
        }
	System.out.print("Sender bei ");
        for(int frequency : frequencies) {
            System.out.print(frequency + " ");
        }
	System.out.println();
   }

    public void onoff() {
        System.out.print("onoff [" + f);
        if (state==State.OFF) {
            f = MAX;
            System.out.println(" -> " + f + "] locked");
            state = State.LOCKED;
            operator = new Thread(this);
            operator.start();
        }
        else {
        	if (state == State.INSHUTDOWN)
        		System.out.println("System in shutdown.");
        	else {
                 state = State.INSHUTDOWN;
                 f = 0;
                 System.out.println(" -> " + f + "]");
        	}
        }
    }

    public void down() {
        if (state==State.LOCKED) {
            System.out.println("down [" + f + "]");
            if (f > MIN)
                godown();
            else if (f == MIN)
                gomax();
        }
        else if (state==State.DOWN || state==State.UP) {
            System.out.println("down [" + f + "] locked");
            state = State.LOCKED;
        }
    }

    public void up() {
        if (state==State.LOCKED) {
            System.out.println("up [" + f + "]");
            if (f < MAX) 
                goup();
            else if (f==MAX) 
                gomin();
        }
        else if (state==State.DOWN || state==State.UP) {
            System.out.println("up [" + f + "] locked");
            state = State.LOCKED;
        }
    }

    private void godown() {
        System.out.print("godown [" + f);
        f--;
        System.out.println(" -> " + f + "]");
        state = State.DOWN;
    }
    
    private void gomax() {
        System.out.print("gomax [" + f);
        f=MAX;
        System.out.println(" -> " + f + "]");
        state = State.DOWN;
    }

    private void goup() {
        System.out.print("goup [" + f);
        f++;
        System.out.println(" -> " + f + "]");
        state = State.UP;
    }

    private void gomin() {
        System.out.print("gomin [" + f);
        f = MIN;
        System.out.println(" -> " + f + "]");
        state = State.UP;
    }

    private void lock() {
        System.out.println("lock [" + f + "] locked");
        state = State.LOCKED;
    }
 
    public void run() {
        while (true) {
            if (state==State.INSHUTDOWN) {
                state = State.OFF;
                return;  
            } 
            if ((state==State.DOWN || state==State.UP)
                 && sender[f]) {
                lock();
            }
            else if (state==State.DOWN) {
                if (f > MIN)
                    godown();
                else if (f == MIN)
                    gomax();
            }
            else if (state==State.UP) {
                if (f < MAX)
                    goup();
                else if (f == MAX) {
                    gomin();  
                }
            }
            try {
                Thread.sleep(1500);
            }
            catch (InterruptedException e) {
                System.out.println("Could not sleep?");
            }
        }//while
    }//run
}

