

import javax.swing.*;          
import java.awt.*;
import java.awt.event.*;

public class SwingUserINSHUTDOWN implements Runnable {
    
    protected ARadioINSHUTDOWN myRadio;
    private JButton onoffButton;
    private JButton upButton;
    private JButton downButton;
    
    public SwingUserINSHUTDOWN(ARadioINSHUTDOWN r) {
        myRadio = r;
    }
    
    public void run() {
        createAndShowGUI();
    } 
    
    public void start() {
         javax.swing.SwingUtilities.invokeLater(this);       
    }
    
    public class onoffListener  implements ActionListener {
        public void actionPerformed(ActionEvent e) {
            myRadio.onoff();
//            onoffButton.setEnabled(true);
//            upButton.setEnabled(true);
//            downButton.setEnabled(true);
        }
    }
        
    public class upListener implements ActionListener {
        public void actionPerformed(ActionEvent e) {
            myRadio.up();
        }
    }
    
    public class downListener implements ActionListener {
        public void actionPerformed(ActionEvent e) {
            myRadio.down();
        }
    }
    
    final static String LOOKANDFEEL = null;
    
    public Component createComponents() {
        onoffButton = new JButton("Onoff");
        upButton = new JButton("Up");
        downButton = new JButton("Down");
        onoffButton.addActionListener(new onoffListener());
        upButton.addActionListener(new upListener());
        downButton.addActionListener(new downListener());

        JPanel pane = new JPanel(new GridLayout(0, 1));
        pane.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
        pane.add(onoffButton);
        onoffButton.setEnabled(true);
        pane.add(upButton);
        upButton.setEnabled(true);
        pane.add(downButton);
        downButton.setEnabled(true);

        return pane;
    }

    private static void initLookAndFeel() {
        String lookAndFeel = null;

        if (LOOKANDFEEL != null) {
            if (LOOKANDFEEL.equals("Metal")) {
                lookAndFeel = UIManager.getCrossPlatformLookAndFeelClassName();
            } else if (LOOKANDFEEL.equals("System")) {
                lookAndFeel = UIManager.getSystemLookAndFeelClassName();
            } else if (LOOKANDFEEL.equals("Motif")) {
                lookAndFeel = "com.sun.java.swing.plaf.motif.MotifLookAndFeel";
            } else if (LOOKANDFEEL.equals("GTK+")) { //new in 1.4.2
                lookAndFeel = "com.sun.java.swing.plaf.gtk.GTKLookAndFeel";
            } else {
                System.err.println("Unexpected value of LOOKANDFEEL specified: "
                                   + LOOKANDFEEL);
                lookAndFeel = UIManager.getCrossPlatformLookAndFeelClassName();
            }

            try {
                UIManager.setLookAndFeel(lookAndFeel);
            } catch (ClassNotFoundException e) {
                System.err.println("Couldn't find class for specified look and feel:"
                                   + lookAndFeel);
                System.err.println("Did you include the L&F library in the class path?");
                System.err.println("Using the default look and feel.");
            } catch (UnsupportedLookAndFeelException e) {
                System.err.println("Can't use the specified look and feel ("
                                   + lookAndFeel
                                   + ") on this platform.");
                System.err.println("Using the default look and feel.");
            } catch (Exception e) {
                System.err.println("Couldn't get specified look and feel ("
                                   + lookAndFeel
                                   + "), for some reason.");
                System.err.println("Using the default look and feel.");
                e.printStackTrace();
            }
        }
    }
    
    /**
     * Create the GUI and show it.  For thread safety,
     * this method should be invoked from the
     * event-dispatching thread.
     */
    private void createAndShowGUI() {
        //Set the look and feel.
        initLookAndFeel();

        //Make sure we have nice window decorations.
        JFrame.setDefaultLookAndFeelDecorated(true);

        //Create and set up the window.
        JFrame frame = new JFrame("Autoradio Simulation");
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        
        Component contents = createComponents();
        frame.getContentPane().add(contents, BorderLayout.CENTER);

        //Display the window.
        //frame.pack();
        frame.setSize(200,400);
        frame.setVisible(true);
    }

}

